<template>
  <div
      v-if="Boolean(data)"
      class="ob-order-event"
  >
    <div class="ob-order-event__datetime">
      {{ data.occurredAt | date('HH:mm') }}<br>
      {{ data.occurredAt | date('DD.MM.YYYY') }}
    </div>
    <div class="ob-order-event__title">
      <div class="title">{{ data.title }}</div>
      <ObShowMore
          v-if="Boolean(data.description)"
          :height="32"
          :is-compact="true"
      >
        <div class="description">{{ data.description }}</div>
      </ObShowMore>
    </div>
    <div
        class="ob-order-event__files"
    >
      <ObMenuDropdown
          v-if="filesCount"
          ref="dropdown"
          :remote-opt="getFilesName"
      >
        <div
            class="dropdown-button"
            slot="button"
        >
          <i class="icon attach" />
          <span>{{ filesCount }}</span>
        </div>
      </ObMenuDropdown>
    </div>
    <div class="ob-order-event__source">
      <template v-if="participant">
        <div class="creator-info">
          <div
              class="creator-info__participant"
              :title="participant"
          >
            {{ participant }}
          </div>
          <div
              class="creator-info__user"
              :title="user"
          >
            {{ user }}
          </div>
        </div>
        <i
            v-if="uesrIcon"
            class="icon"
            :class="uesrIcon"
        />
      </template>
      <template v-else>
        Системное
      </template>
    </div>
  </div>
</template>

<script>
import api from '@/api'
import ObShowMore from 'common-components/src/obComponents/obShowMore'
import ObMenuDropdown from 'common-components/src/obComponents/obMenuDropdown'

export default {
  name: 'TrackingOrderEvent',
  props: {
    data: {
      type: Object,
      default: null
    }
  },
  components: {
    ObShowMore,
    ObMenuDropdown
  },
  computed: {
    uesrIcon () {
      const iconMap = {
        CLIENT: 'role-client',
        CLICAR: 'role-domain-owner',
        CARRIER: 'carrier',
        EXPEDITOR: 'role-domain-owner'
      }

      return iconMap[this.data.creatorType] || null
    },
    participant () {
      return this.data.creatorTitle || null
    },
    user () {
      return this.data.authorTitle || null
    },
    filesCount () {
      return this.data.fileUuids ? this.data.fileUuids.length : 0
    }
  },
  methods: {
    async getFilesName () {
      try {
        const names = await api.files.getFilesName({ uuids: this.data.fileUuids })
        return [
          ...names.map(({ fileUuid, fileName }) => {
            return {
              uuid: fileUuid,
              title: fileName,
              icon: 'attach',
              method: () => this.downloadFile(fileUuid)
            }
          }),
          {
            uuid: 'all',
            title: 'Скачать все файлы',
            icon: 'download',
            isHidden: names.length < 2,
            method: () => this.downloadAllFiles()
          }
        ]
      } catch (e) {
        this.$notification({
          type: 'system_notification_error',
          message: `Ошибка загрузки данных`
        })
      }
    },
    async downloadFile (uuid, isNotification) {
      try {
        await api.files.getFile(uuid, true)
        if (isNotification) {
          this.$notification({
            type: 'system_notification_success',
            message: `Файл успешно загружен`
          })
        }
      } catch (e) {
        if (isNotification) {
          this.$notification({
            type: 'system_notification_error',
            message: `Ошибка загрузки файла`
          })
        }
      }
    },
    async downloadAllFiles () {
      const notificationId = `${new Date().getTime()}save`

      this.$notification({
        type: 'system_notification_in_load',
        message: `Загрузка файлов`,
        id: notificationId
      })

      try {
        let promises = []

        this.filesData.forEach(({ uuid }) => {
          promises.push(this.downloadFile(uuid, false))
        })

        await Promise.all(promises)

        this.$notification({
          type: 'system_notification_success',
          message: `Файлы успешо загружены`,
          id: notificationId
        })
      } catch (e) {
        this.$notification({
          type: 'system_notification_error',
          message: `Ошибка загрузки файлов`,
          id: notificationId
        })
      } finally {
        this.$notification({event: 'close', id: notificationId})
      }
    },
  }
}
</script>

<style lang="scss" scoped>
@import "~common-components/src/static/css/mixins";

.ob-order-event {
  display: flex;
  margin-bottom: 2px;
  padding: 6px 20px;
  background-color: $light-lavender;
  &__datetime {
    width: 70px;
    flex-shrink: 0;
    @include font-mixin(11px, 18px, 400, $color-grey-span, 0.4px);
    text-align: left;
  }
  &__title {
    display: flex;
    flex-direction: column;
    justify-content: center;
    margin-left: 50px;
    margin-right: 50px;
    flex-grow: 2;
    .title {
      @include font-mixin(12px, 16px, 400, $color-text-base, 0.2px);
    }
    .description {
      @include font-mixin(12px, 16px, 400, $color-grey-span, 0.2px);
    }
    &::v-deep {
      .ob-show-more-container {
        margin-top: 2px;
        .toggle-button {
          padding: 0 3px!important;
          background-color: $light-lavender!important;
        }
      }
    }
  }
  &__files {
    display: flex;
    align-items: center;
    width: 30px;
    flex-shrink: 0;
    max-height: 48px;
    margin-right: 30px;
    .dropdown-button {
      position: absolute;
      z-index: 3;
      display: flex;
      align-items: center;
      i {
        position: relative;
        font-size: 12px;
      }
      span {
        margin-left: 3px;
        @include font-mixin(12px, 16px, 400, $color-text-base, 0.2px);
      }
    }
  }
  &__source {
    display: flex;
    align-items: center;
    width: 250px;
    max-height: 48px;
    flex-shrink: 0;
    justify-content: flex-end;
    text-align: right;
    @include font-mixin(12px, 14px, 400, $color-grey-span, 0.4px);
    .creator-info {
      min-width: 0;
      flex-grow: 2;
      &__participant {
        white-space: nowrap;
        overflow: hidden;
        text-overflow: ellipsis;
        @include font-mixin(12px, 16px, 400, $color-grey-span, 0.2px);
      }
      &__user {
        margin-top: 2px;
        white-space: nowrap;
        overflow: hidden;
        text-overflow: ellipsis;
        @include font-mixin(12px, 16px, 400, $color-grey-span, 0.2px);
      }
    }
    .icon {
      margin-left: 8px;
      color: $color-blue-navy-blue;
      font-size: 16px;
    }
  }
}
</style>
